class XTFinishersDefaultSlowdownParams {
	//==========================
	// GENERAL SETTINGS 
	//==========================
	public const var SLOWDOWN_DISABLE_CAMERA_SHAKE : bool;
		default SLOWDOWN_DISABLE_CAMERA_SHAKE = true;					// ΪtrueʱʵͷʱֹͷҡΣIf TRUE -> prevents camera shake when a slowdown is activated.
	
	//==================================================
	// SLOWDOWN ON FATAL HIT SETTINGS һͷ
	//==================================================
	
	public const var SLOWDOWN_FATAL_CHANCE : float;
		default SLOWDOWN_FATAL_CHANCE = 0.0;						// һͷʣChance to activate slow motion on a fatal hit.
	public const var SLOWDOWN_FATAL_DELAY, SLOWDOWN_FATAL_FACTOR, SLOWDOWN_FATAL_DURATION : float;
		default SLOWDOWN_FATAL_DELAY = 0.1;						// һͷʱ룩Delay after fatal hit is performed before slow motion activates (seconds in game time).
		default SLOWDOWN_FATAL_FACTOR = 0.3;						// һͷʱϵԽСԽTime factor for slow motion during a fatal hit (smaller number = more slowdown).
		default SLOWDOWN_FATAL_DURATION = 0.3;						// һͷʱ䣨룩Duration of slow motion during a fatal hit (seconds in game time).
	
	//=================================================
	// SLOWDOWN ON CRITICAL HIT SETTINGS ͷ
	//=================================================
	
	public const var SLOWDOWN_CRIT_CHANCE_NONFATAL, SLOWDOWN_CRIT_CHANCE_FATAL, SLOWDOWN_CRIT_CHANCE_FATAL_LAST_ENEMY : float;
		default SLOWDOWN_CRIT_CHANCE_NONFATAL = 0.0;					// ʵзʱͷʣChance to activate slow motion when a critical hit is performed on a non-fatal attack.
		default SLOWDOWN_CRIT_CHANCE_FATAL = 0.0;					// ʵʱͷʣChance to activate slow motion when a critical hit is performed on a fatal attack.
		default SLOWDOWN_CRIT_CHANCE_FATAL_LAST_ENEMY = 100.0;			        // ʵʱͷʣChance to activate slow motion when a critical hit is performed on a fatal attack on the LAST enemy in combat.
	public const var SLOWDOWN_CRIT_FACTOR, SLOWDOWN_CRIT_DURATION, SLOWDOWN_CRIT_DELAY : float;
		default SLOWDOWN_CRIT_DELAY = 0.1;						// ͷʱ룩Delay after critical hit is triggered before slow motion activates (seconds in game time).
		default SLOWDOWN_CRIT_FACTOR = 0.3;						// ͷʱϵԽСԽTime factor for slow motion during a critical hit (smaller number = more slowdown).
		default SLOWDOWN_CRIT_DURATION = 0.3;						// ͷʱ䣨룩Duration of slow motion during a critical hit (seconds in game time).
	
	//=============================================
	// SLOWDOWN ON FINISHER SETTINGS սͷ
	//=============================================
	
	public const var SLOWDOWN_FINISHER_CHANCE, SLOWDOWN_FINISHER_AUTO_CHANCE, SLOWDOWN_FINISHER_INSTANTKILL_CHANCE : float;
		default SLOWDOWN_FINISHER_CHANCE = 0.0;					        // ʵϷĬսʱͷʣChance to activate slow motion when a REGULAR or DEBUG finisher is triggered.
		default SLOWDOWN_FINISHER_AUTO_CHANCE = 0.0;					// ʵԶսʱͷʣChance to activate slow motion when an AUTOMATIC finisher is triggered.
		default SLOWDOWN_FINISHER_INSTANTKILL_CHANCE = 0.0;			        // ʵбɱսʱͷʣChance to activate slow motion when an INSTANT-KILL finisher is triggered.
	public const var SLOWDOWN_FINISHER_CHANCE_LAST_ENEMY, SLOWDOWN_FINISHER_AUTO_CHANCE_LAST_ENEMY, SLOWDOWN_FINISHER_INSTANTKILL_CHANCE_LAST_ENEMY : float;
		default SLOWDOWN_FINISHER_CHANCE_LAST_ENEMY = 100.0;			        // ʵϷĬսʱͷʣChance to activate slow motion when a REGULAR or DEBUG finisher is triggered on the LAST enemy in combat.
		default SLOWDOWN_FINISHER_AUTO_CHANCE_LAST_ENEMY = 100.0;		        // ʵԶսʱͷʣChance to activate slow motion when an AUTOMATIC finisher is triggered on the LAST enemy in combat.
		default SLOWDOWN_FINISHER_INSTANTKILL_CHANCE_LAST_ENEMY = 100;	                // ʵбɱսʱͷʣChance to activate slow motion when an INSTANT-KILL finisher is triggered on the LAST enemy in combat
	public const var SLOWDOWN_FINISHER_A_FACTOR, SLOWDOWN_FINISHER_A_DURATION, SLOWDOWN_FINISHER_A_DELAY : float;
		default SLOWDOWN_FINISHER_A_DELAY = 0.0;					// ʵսʱһͷʱ룩Delay after finisher is triggered before first slow motion section activates (seconds in game time).
		default SLOWDOWN_FINISHER_A_FACTOR = 0.3;					// һսͷʱϵԽСԽTime factor for first slow motion section during a finisher (smaller number = more slowdown).
		default SLOWDOWN_FINISHER_A_DURATION = 0.3;					// һսͷʱ䣨룩Duration of first slow motion section during a finisher (seconds in game time).
	public const var SLOWDOWN_FINISHER_B_FACTOR, SLOWDOWN_FINISHER_B_DURATION, SLOWDOWN_FINISHER_B_DELAY : float;
		default SLOWDOWN_FINISHER_B_DELAY = 1.15;					// ʵսʱڶͷʱ룩Delay after first slow motion section finishes before second slow motion section activates (seconds in game time).
		default SLOWDOWN_FINISHER_B_FACTOR = 0.3;					// ڶսͷʱϵԽСԽTime factor for second slow motion section during a finisher (smaller number = more slowdown).
		default SLOWDOWN_FINISHER_B_DURATION = 0.3;					// ڶսͷʱ䣨룩Duration of second slow motion section during a finisher (seconds in game time).
	
	public const var SLOWDOWN_FINISHER_KNOCKDOWN_CHANCE, SLOWDOWN_FINISHER_KNOCKDOWN_CHANCE_LAST_ENEMY : float;
		default SLOWDOWN_FINISHER_KNOCKDOWN_CHANCE = 0.0;				// ʵлսʱͷʣChance to activate slow motion when a KNOCKDOWN finisher is triggered.
		default SLOWDOWN_FINISHER_KNOCKDOWN_CHANCE_LAST_ENEMY = 100.0;	                // ʵлսʱͷʣChance to activate slow motion when a KNOCKDOWN finisher is triggered on the LAST enemy in combat.
	public const var SLOWDOWN_FINISHER_KNOCKDOWN_FACTOR, SLOWDOWN_FINISHER_KNOCKDOWN_DURATION, SLOWDOWN_FINISHER_KNOCKDOWN_DELAY : float;
		default SLOWDOWN_FINISHER_KNOCKDOWN_DELAY = 1.3;				// սͷʱ룩Delay after KNOCKDOWN finisher is triggered before slow motion activates (seconds in game time).
		default SLOWDOWN_FINISHER_KNOCKDOWN_FACTOR = 0.3;				// սͷʱϵԽСԽTime factor for slow motion during a KNOCKDOWN finisher (smaller number = more slowdown).
		default SLOWDOWN_FINISHER_KNOCKDOWN_DURATION = 0.3;				// սͷʱ䣨룩Duration of slow motion during a KNOCKDOWN finisher (seconds in game time).
	
	//==============================================
	// SLOWDOWN ON DISMEMBER SETTINGS ֫ͷ
	//==============================================
	
	public const var SLOWDOWN_DISMEMBER_CHANCE, SLOWDOWN_DISMEMBER_FROZEN_CHANCE, SLOWDOWN_DISMEMBER_BOMB_CHANCE, SLOWDOWN_DISMEMBER_BOLT_CHANCE, SLOWDOWN_DISMEMBER_YRDEN_CHANCE, SLOWDOWN_DISMEMBER_TOXICCLOUD_CHANCE, SLOWDOWN_DISMEMBER_AUTO_CHANCE,
			SLOWDOWN_DISMEMBER_CHANCE_LAST_ENEMY, SLOWDOWN_DISMEMBER_FROZEN_CHANCE_LAST_ENEMY, SLOWDOWN_DISMEMBER_BOMB_CHANCE_LAST_ENEMY, SLOWDOWN_DISMEMBER_BOLT_CHANCE_LAST_ENEMY, SLOWDOWN_DISMEMBER_YRDEN_CHANCE_LAST_ENEMY, SLOWDOWN_DISMEMBER_TOXICCLOUD_CHANCE_LAST_ENEMY, SLOWDOWN_DISMEMBER_AUTO_CHANCE_LAST_ENEMY : float;
		default SLOWDOWN_DISMEMBER_CHANCE = 0.0;					// ϷĬ֫ʱͷʣChance to activate slow motion when a REGULAR or DEBUG dismember is triggered.
		default SLOWDOWN_DISMEMBER_FROZEN_CHANCE = 0.0;				        // ֫ʱͷʣChance to activate slow motion when a FROZEN dismember is triggered.
		default SLOWDOWN_DISMEMBER_BOMB_CHANCE = 0.0;					// ʮֹ֫ʱͷʣChance to activate slow motion when a BOLT dismember is triggered.
		default SLOWDOWN_DISMEMBER_BOLT_CHANCE = 0.0;					// ը֫ʱͷʣChance to activate slow motion when a BOMB dismember is triggered.
		default SLOWDOWN_DISMEMBER_YRDEN_CHANCE = 0.0;					// ǵ֫ʱͷʣChance to activate slow motion when a YRDEN dismember is triggered.
		default SLOWDOWN_DISMEMBER_TOXICCLOUD_CHANCE = 0.0;				// ֫ʱͷʣChance to activate slow motion when a TOXIC CLOUD dismember is triggered.
		default SLOWDOWN_DISMEMBER_AUTO_CHANCE = 0.0;					// Զ֫ʱͷʣChance to activate slow motion when an AUTOMATIC dismember is triggered.
		default SLOWDOWN_DISMEMBER_CHANCE_LAST_ENEMY = 100.0;				// ϷĬ֫ʱͷʣChance to activate slow motion when a REGULAR or DEBUG dismember is triggered on the LAST enemy in combat.
		default SLOWDOWN_DISMEMBER_FROZEN_CHANCE_LAST_ENEMY = 100.0;		        // ˱֫ʱͷʣChance to activate slow motion when a FROZEN dismember is triggered on the LAST enemy in combat.
		default SLOWDOWN_DISMEMBER_BOMB_CHANCE_LAST_ENEMY = 100.0;			// ը֫ʱͷʣChance to activate slow motion when a BOMB dismember is triggered on the LAST enemy in combat.
		default SLOWDOWN_DISMEMBER_BOLT_CHANCE_LAST_ENEMY = 100.0;			// ʮֹ֫ʱͷʣChance to activate slow motion when a BOLT dismember is triggered on the LAST enemy in combat.
		default SLOWDOWN_DISMEMBER_YRDEN_CHANCE_LAST_ENEMY = 100.0;			// ǵ֫ʱͷʣChance to activate slow motion when a YRDEN dismember is triggered on the LAST enemy in combat.
		default SLOWDOWN_DISMEMBER_TOXICCLOUD_CHANCE_LAST_ENEMY = 100.0;	        // ˶֫ʱͷʣChance to activate slow motion when a TOXIC CLOUD dismember is triggered on the LAST enemy in combat.
		default SLOWDOWN_DISMEMBER_AUTO_CHANCE_LAST_ENEMY = 100.0;			// Զ֫ʱͷʣChance to activate slow motion when an AUTOMATIC dismember is triggered on the LAST enemy in combat.
	public const var SLOWDOWN_DISMEMBER_FACTOR, SLOWDOWN_DISMEMBER_DURATION, SLOWDOWN_DISMEMBER_DELAY : float;
		default SLOWDOWN_DISMEMBER_DELAY = 0.1;						// ֫ͷʱ룩Delay after dismember is triggered before slow motion activates (seconds in game time).
		default SLOWDOWN_DISMEMBER_FACTOR = 0.3;					// ֫ͷʱϵԽСԽTime factor for slow motion during a dismember (smaller number = more slowdown).
		default SLOWDOWN_DISMEMBER_DURATION = 0.3;					// ֫ͷʱ䣨룩Duration of slow motion during a dismember (seconds in game time).
		
}